//примитивы используемые в редакторе

function deselectFunc(obj) {
    /*
     *  Снимает выделение с выбранного объекта (поля)
     *  @obj {Object} - объект (поле) с которого нужно снять выделение
     */
    var transparent_color = new RgbColor(255, 255, 255, 0);

    for (var l = 0; l < obj.lines.length; l++) {
        if (editMode == 0) {
            obj.lines[l].strokeColor = obj.unselect_color;
        }
        else {
            obj.lines[l].strokeColor = transparent_color;
        }
    }

    obj.boundedRectangle.strokeColor = transparent_color;
}

baseField = {
    /*
    * Поле редактора доступное для редактирования (ввод текста, перемещение)
    */
    showTooltip: true,
    manager: null,
    idx: 0,
    center: null,
    width: 0,
    height: 0,
    deselect : deselectFunc,
    unselect_color: '#000000',
    remove: function() {
        this.group_.remove();
    },
    updateCenter: function(self_id, new_center_point) {
        this.center = new_center_point;
    },
    updateLeft: function(self_id, new_left_point) {
        this.center = new Point(
            new_left_point + this.width/2,
            this.center.y);
    },
    updateWidth: function(self_id, new_width) {
        this.width = new_width;
    },
    updateTop: function(self_id, new_top_point) {
        this.center = new Point(
            this.center.x,
            new_top_point + this.height/2);
    },
    updateHeight: function(self_id, new_height) {
        this.height = new_height;
    },
    update_BRecGeometry: function(self_id, xofs,yofs) {
        this.boundedRectangle.translate(
            new Point(xofs, yofs));

        var scaleY = (this.height-6) / this.boundedRectangle.bounds.height;
        var scaleX = (this.width-6) / this.boundedRectangle.bounds.width;

        this.boundedRectangle.scale(scaleX, scaleY);
    },
    getLinked: function(self_id) {
        var lst = [], mgr = this.manager;
        for (var r in mgr) {
            if (mgr[r].linked_id[0] == self_id) {
                lst.push(parseInt(r));
            }
        }
        return lst;
    },
    isLinked: function(self_id) {
        return this.linked_id[0] == -1;
    },
    copy: function(source, target) {
        target.center = source.center;
        target.width = source.width;
        target.height = source.height;
        target.lines = source.lines;
        target.group_ = source.group_;
        target.value = source.value;
        target.boundedRectangle = source.boundedRectangle;
    },
    getChildrens: function() {
        var childs = this.group_.children;
        return childs;
    },
    group_ : null,
    //текст который вставляется в поле при печати
    value: null,
    //параметры текста, такие как
    text_params: null,
    boundedRectangle: null,
    id_text: null,
    //связанное поле из которого берется текст,
    //первый индекс - номер поля,
    //второй индекс - номер строки
    linked_id : [-1, 0],
    print: true,
    descr: "",
    hyphenate: false,
    base_text: "",
    user_text: ""
};

function Rectangle(config) {
    this.lines = [];
    this.text_params = {
        //строки текста на которые разбита общая строка
        rows: [],
        //отступ от края поля
        rows_offset: [],
        font_type: "",
        font_size: ""
    };
    //расширение конфигурации по умолчанию
    $.extend(this, config);
}

Rectangle.prototype = baseField;