
define('drawing/manipulator', ['jquery', 'paper'], function($, Paper) {
    //определение классов манипулятор
    //Манипулятор позволяет управлять группой объектов в редакторе
    //отвечает за перемещение и привязку данных

    var Manipulator = {
        lastPositions: [],
        reversePositions: [],
        viewOnStartup: true,
        init: function() {
            this.defineElements();
            if (!this.viewOnStartup) {
                this.setupElement.css('display', 'none');
            }
            this.showSetup();
            this.createEvents();
        },
        showSetup: function() {
            var me = this,
                checkbox = me.optionShowElement.children(0);
            checkbox.on("change",
                function(e) {
                    if (this.control.checked) {
                        me.setupElement.css('display', 'block');
                    }
                    else {
                        me.setupElement.css('display', 'none');
                    }
                }
            )
        },
        getObjectById: function(id) {},
        createEvents: function() {},
        getObjectsConfiguration: function() {
            /*  Шаблонный метод для определения конфигурации объектов слоя*/
            return {}
        },
        moveBorder: function(border, moveOffset) {
            //перемещение окантовки объекта
            var parent = getParentLine(border),
                object_id = parent[1], object_ = parent[0],
                object = this.getObjectById(object_id);
            if (object) {
                var old_height = object.height,
                    old_width = object.width,
                    scale_xfactor = 1,
                    scale_yfactor = 1,
                    x_offset = 0,
                    y_offset = 0;

                if (border.position.x == object.lines[0].position.x &&
                    border.position.y == object.lines[0].position.y) {
                    border.position.y += moveOffset.y;
                    object.height += -1* moveOffset.y;
                    object.center.y += moveOffset.y / 2;
                    scale_yfactor = object.height/old_height;
                    y_offset = moveOffset.y / 2;
                    object.lines[1].translate(new Point(0, moveOffset.y / 2));
                    object.lines[1].scale(scale_yfactor);
                    object.lines[3].translate(new Point(0, moveOffset.y / 2));
                    object.lines[3].scale(scale_yfactor);
                }
                else if (border.position.x == object.lines[1].position.x &&
                    border.position.y == object.lines[1].position.y) {
                    border.position.x += moveOffset.x;
                    object.width += moveOffset.x;
                    object.center.x += moveOffset.x / 2;
                    scale_xfactor = object.width/old_width;
                    x_offset = moveOffset.x / 2;
                    object.lines[0].translate(new Point(moveOffset.x / 2, 0));
                    object.lines[0].scale(scale_xfactor);
                    object.lines[2].translate(new Point(moveOffset.x / 2, 0));
                    object.lines[2].scale(scale_xfactor);
                }
                else if (border.position.x == object.lines[2].position.x &&
                    border.position.y == object.lines[2].position.y) {
                    border.position.y += moveOffset.y;
                    object.height += moveOffset.y;
                    object.center.y += moveOffset.y / 2;
                    scale_yfactor = object.height/old_height;
                    y_offset = moveOffset.y / 2;

                    object.lines[1].translate(new Point(0, moveOffset.y / 2));
                    object.lines[1].scale(scale_yfactor);
                    object.lines[3].translate(new Point(0, moveOffset.y / 2));
                    object.lines[3].scale(scale_yfactor);
                }
                else if (border.position.x == object.lines[3].position.x &&
                    border.position.y == object.lines[3].position.y) {
                    border.position.x += moveOffset.x;
                    object.width += (-1) * moveOffset.x;
                    object.center.x += moveOffset.x / 2;
                    scale_xfactor = object.width/old_width;
                    x_offset = moveOffset.x / 2;

                    object.lines[0].translate(new Point(moveOffset.x / 2,0));
                    object.lines[0].scale(scale_xfactor);
                    object.lines[2].translate(new Point(moveOffset.x / 2,0));
                    object.lines[2].scale(scale_xfactor);
                }
                //после изменений размеров отдельных ребер надо изменить размер обрамления
                object.boundedRectangle.translate(
                    new Point(x_offset,
                        y_offset));
                var scaleY = (object.height - 6) / object.boundedRectangle.bounds.height;
                var scaleX = (object.width - 6) / object.boundedRectangle.bounds.width;
                object.boundedRectangle.scale(scaleX, scaleY);
            }
        },
        moveObject: function(object, moveOffset) {
            //перемещение поля по холсту
            if (this.layer === this.project.activeLayer) {
                var me = this,
                    movedObject = me.getParentGroup(object.parent),
                    object_id = movedObject[1],
                    select_object = movedObject[0],
                    object_wrapper = me.getObjectById(object_id),
                    object_childs = object_wrapper.getChildrens();

                console.log(select_object);
                for (var c = 0; c < object_childs.length; c++) {
                    object_childs[c].translate(moveOffset);
                }
                me.updatePosition(select_object, object_id, me.selected);
                me.updatePositionData(object_id);
            }
        },
        updatePosition: function(obj, obj_id, selected_item) {
            var parent = selected_item.parent;
            obj.updateCenter(obj_id,
                new Point(
                    parent.strokeBounds.x + parent.strokeBounds.width / 2,
                    parent.strokeBounds.y + parent.strokeBounds.height / 2)
            );
        },
        updatePositionData: function(object_id) {
            updateCoords(object_id);
        },
        setInitalPosition: function(x, y) {
            //устанавливаем начальную позицию для элементов группы
        },
        getCurrentPosition: function() {
            //берем текущую оторбражаемую позицию
        },
        moveFields: function() {

        },
        getFields: function() {
            //возвращает набор которым управляет манипулятор

        },
        addToGroup: function(field) {
            //добавление элемента в группу

        }
    };

    return Manipulator
});