

define('models/text_layer', ['backbone', 'models/layer_model'],

    function(Backbone, LayerModel) {

        return LayerModel.extend({
            onActivate: function() {
                //TODO - разобраться как нормально передавать аргументы в функцию обработки
                var layer_mgr_view = this[0],
                    that = this[1], collection = this[2],
                    drawer = layer_mgr_view.drawingDelegate;

                var promise = that.loadDataToObjects()['promise'],
                    doneCallbacks, failCallback;

                var closure = (function(collection) {

                    var wraps = function() {

                        var text_ = $('.text_field');
                        text_.remove();
                        //пробегаем по коллекции о отрисовываем текст
                        collection.each(function(object) {

                            var text_params = object.get('text_params'),
                                cell_text = text_params.rows[0] || object.get('base_text'),
                                cell_position = object.get('center'),
                                printable = object.get('print');

                            if (printable) {
                                drawer.createText('DIVS',
                                    cell_text,
                                    text_params.font_type,
                                    text_params.font_size,
                                    object.get('width'),
                                    object.get('height'),
                                    {x: cell_position.x, y: cell_position.y},
                                    'body',
                                    object.get('printOffsetLeft'),
                                    object.get('printOffsetTop'),
                                    object.get('offsetType')
                                )
                            }
                        });
                    };
                    return wraps;

                })(that.objectsCollection);

                promise.done(closure);

            },
            onDeactivate: function() {
                var layer_mgr_view = this[0],
                    that = this[1], collection = this[2],
                    drawer = layer_mgr_view.drawingDelegate;
                console.log('on TEXT LAYER deactivate');

                that.objectsCollection.each(function(object) {
                    var value = object.get('value');
                    if (value) {
                        drawer.destroyText(value);
                    }
                });
                drawer.clearText($('body'));
                layer_mgr_view.editor.canvas.css('display', 'block');
            }
        });
    }
);
