define('views/font_setup_view', ['jquery', 'backbone', 'views/tool_view'],
	function($, Backbone, ToolView) {
		var template = [
			'<div class="akordeon-item expanded">',
				'<div class="akordeon-item-head"><div class="akordeon-item-head-container">',
				'<div class="akordeon-heading"><h3>Настройки шрифта</h3></div></div></div>',
                '<div class="instrument_line akordeon-item-body">',
                '<div class="akordeon-item-content">',
                	'<select id="font_selector" style="width: 50%;">',
		                '<option value="Book Antiqua">Book Antiqua</option>',
						'<option value="Book Antiqua Bold">Book Antiqua Bold</option>',
						'<option value="Book Antiqua Italic">Book Antiqua Italic</option>',
						'<option value="Arial">Arial</option>',
						'<option value="Arial Bold">Arial Bold</option>',
						'<option value="Arial Bold Italic">Arial Bold Italic</option>',
						'<option value="Arial Italic">Arial Italic</option>',
						'<option value="Arial Narrow">Arial Narrow</option>',
						'<option value="Arial Narrow Bold">Arial Narrow Bold</option>',
						'<option value="Arial Narrow Bold Italic">Arial Narrow Bold Italic</option>',
						'<option value="Arial Narrow Italic">Arial Narrow Italic</option>',
						'<option value="Arial Unicode MS">Arial Unicode MS</option>',
						'<option value="Bookman Old Style">Bookman Old Style</option>',
						'<option value="Bookman Old Style Black">Bookman Old Style Black</option>',
						'<option value="Bookman Old Style Bold Italic">Bookman Old Style Bold Italic</option>',
						'<option value="Bookman Old Style Italic">Bookman Old Style Italic</option>',
						'<option value="Cambria">Cambria</option>',
						'<option value="Cambria Bold">Cambria Bold</option>',
						'<option value="Cambria Italic">Cambria Italic</option>',
						'<option value="CambriaZ">CambriaZ</option>',
						'<option value="Candara">Candara</option>',
						'<option value="Candara Bold">Candara Bold</option>',
						'<option value="Candara Italic">Candara Italic</option>',
						'<option value="CandaraZ">CandaraZ</option>',
						'<option value="Century Schoolbook">Century Schoolbook</option>',
						'<option value="Century">Century</option>',
						'<option value="Comic Sans">Comic Sans</option>',
						'<option value="Comic Sans Bold">Comic Sans Bold</option>',
						'<option value="Consola">Consola</option>',
						'<option value="Consola Bold">Consola Bold</option>',
						'<option value="Consola Italic">Consola Italic</option>',
						'<option value="Consolaz">Consolaz</option>',
						'<option value="Constantia">Constantia</option>',
						'<option value="Constantia Bold">Constantia Bold</option>',
						'<option value="Constantia Italic">Constantia Italic</option>',
						'<option value="Constantia">Constantia</option>',
						'<option value="Corbel">Corbel</option>',
						'<option value="Corbel Bold">Corbel Bold</option>',
						'<option value="Corbel Italic">Corbel Italic</option>',
						'<option value="CorbelZ">CorbelZ</option>',
						'<option value="Courier">Courier</option>',
						'<option value="Courier Bold">Courier Bold</option>',
						'<option value="Courier Bold Italic">Courier Bold Italic</option>',
						'<option value="Courier Italic">Courier Italic</option>',
						'<option value="DejaVuSans-Bold">DejaVuSans-Bold</option>',
						'<option value="DejaVuSans-BoldOblique">DejaVuSans-BoldOblique</option>',
						'<option value="DejaVuSans-ExtraLight">DejaVuSans-ExtraLight</option>',
						'<option value="DejaVuSans-Oblique">DejaVuSans-Oblique</option>',
						'<option value="DejaVuSans">DejaVuSans</option>',
						'<option value="DejaVuSansCondensed-Bold">DejaVuSansCondensed-Bold</option>',
						'<option value="DejaVuSansCondensed-BoldOblique">DejaVuSansCondensed-BoldOblique</option>',
						'<option value="DejaVuSansCondensed-Oblique">DejaVuSansCondensed-Oblique</option>',
						'<option value="DejaVuSansCondensed">DejaVuSansCondensed</option>',
						'<option value="DejaVuSansMono-Bold">DejaVuSansMono-Bold</option>',
						'<option value="DejaVuSansMono-BoldOblique">DejaVuSansMono-BoldOblique</option>',
						'<option value="DejaVuSansMono-Oblique">DejaVuSansMono-Oblique</option>',
						'<option value="DejaVuSansMono">DejaVuSansMono</option>',
						'<option value="DejaVuSerif-Bold">DejaVuSerif-Bold</option>',
						'<option value="DejaVuSerif-BoldItalic">DejaVuSerif-BoldItalic</option>',
						'<option value="DejaVuSerif-Italic">DejaVuSerif-Italic</option>',
						'<option value="DejaVuSerif">DejaVuSerif</option>',
						'<option value="DejaVuSerifCondensed-Bold">DejaVuSerifCondensed-Bold</option>',
						'<option value="DejaVuSerifCondensed-BoldItalic">DejaVuSerifCondensed-BoldItalic</option>',
						'<option value="DejaVuSerifCondensed-Italic">DejaVuSerifCondensed-Italic</option>',
						'<option value="DejaVuSerifCondensed">DejaVuSerifCondensed</option>',
						'<option value="DroidSansMonoDotted">DroidSansMonoDotted</option>',
						'<option value="Franklin">Franklin</option>',
						'<option value="Franklin Italic">Franklin Italic</option>',
						'<option value="Franklin Demi">Franklin Demi</option>',
						'<option value="Franklin Demi Cond">Franklin Demi Cond</option>',
						'<option value="Franklin Demi Cond Italic">Franklin Demi Cond Italic</option>',
						'<option value="Franklin Heavy">Franklin Heavy</option>',
						'<option value="Franklin Heavy Italic">Franklin Heavy Italic</option>',
						'<option value="Franklin Medium">Franklin Medium</option>',
						'<option value="Franklin Medium Cond">Franklin Medium Cond</option>',
						'<option value="Franklin Medium Italic">Franklin Medium Italic</option>',
						'<option value="Garamond">Garamond</option>',
						'<option value="Garamond Bold">Garamond Bold</option>',
						'<option value="Garamond Italic">Garamond Italic</option>',
						'<option value="Georgia">Georgia</option>',
						'<option value="Georgia Bold">Georgia Bold</option>',
						'<option value="Georgia Italic">Georgia Italic</option>',
						'<option value="Georgia Z">Georgia Z</option>',
						'<option value="Grothic">Grothic</option>',
						'<option value="Gothic Bold">Gothic Bold</option>',
						'<option value="Gothic Bold Italic">Gothic Bold Italic</option>',
						'<option value="Gothic Italic">Gothic Italic</option>',
						'<option value="Hatten">Hatten</option>',
						'<option value="Impact">Impact</option>',
						'<option value="LiberationSansNarrow-Bold">LiberationSansNarrow-Bold</option>',
						'<option value="LiberationSansNarrow-BoldItalic">LiberationSansNarrow-BoldItalic</option>',
						'<option value="LiberationSansNarrow-Italic">LiberationSansNarrow-Italic</option>',
						'<option value="LiberationSansNarrow-Regular">LiberationSansNarrow-Regular</option>',
						'<option value="Lucida">Lucida</option>',
						'<option value="Lucida Console MS">Lucida Console MS</option>',
						'<option value="Sans Serif">Sans Serif</option>',
						'<option value="Monotype Corsiva">Monotype Corsiva</option>',
						'<option value="Palatino">Palatino</option>',
						'<option value="Palatino Bold">Palatino Bold</option>',
						'<option value="Palatino Bold Italic">Palatino Bold Italic</option>',
						'<option value="Palatino Italic">Palatino Italic</option>',
						'<option value="MS Reference Sans Serif">MS Reference Sans Serif</option>',
						'<option value="Century Schoolbook Bold">Century Schoolbook Bold</option>',
						'<option value="Century Schoolbook Bold Italic">Century Schoolbook Bold Italic</option>',
						'<option value="Century Schoolbook Italic">Century Schoolbook Italic</option>',
						'<option value="Sylfaen">Sylfaen</option>',
						'<option value="Tahoma">Tahoma</option>',
						'<option value="Tahoma Bold">Tahoma Bold</option>',
						'<option value="Times New Roman">Times New Roman</option>',
						'<option value="Times New Roman Bold">Times New Roman Bold</option>',
						'<option value="Times New Roman Bold Italic">Times New Roman Bold Italic</option>',
						'<option value="Times New Roman Italic">Times New Roman Italic</option>',
						'<option value="Trebuchet">Trebuchet</option>',
						'<option value="Trebuchet Bold">Trebuchet Bold</option>',
						'<option value="Trebuchet Bold Italic">Trebuchet Bold Italic</option>',
						'<option value="Trebuchet Italic">Trebuchet Italic</option>',
						'<option value="Verdana">Verdana</option>',
						'<option value="Verdana Bold">Verdana Bold</option>',
						'<option value="Verdana Italic">Verdana Italic</option>',
						'<option value="VerdanaZ">VerdanaZ</option>',
					'</select>',
					'<select id="selector_fontsize" style="width: 15%;">',
						'<option value="5">5</option>',
						'<option value="6">6</option>',
						'<option value="8">8</option>',
						'<option value="10">10</option>',
						'<option value="12">12</option>',
						'<option value="14">14</option>',
						'<option value="16">16</option>',
						'<option value="18">18</option>',
						'<option value="20">20</option>',
						'<option value="24">24</option>',
						'<option value="26">26</option>',
						'<option value="28">28</option>',
						'<option value="30">30</option>',
						'<option value="32">32</option>',
						'<option value="34">34</option>',
						'<option value="36">36</option>',
					'</select>',
					'<button>Применить</button>',
                '</div></div>',
			'</div>'
		].join("\r\n");

		var FontSetupView = ToolView.extend({
			template: template,
            events: {
                'change #font_selector': 'onFontTypeChange',
                'change #selector_fontsize': 'onFontSizeChange',
                'click button': 'applyFontParams'
            },
            initialize: function(config) {
                this.model = config['model'];
            },
            onFontTypeChange: function(event) {
                var el = $(event.currentTarget);
                this.model.set('font_type', el.val());
            },
            onFontSizeChange: function(event) {
                var el = $(event.currentTarget);
                this.model.set('font_size', el.val());
            },
            applyFontParams: function() {
                var font_type = this.model.get('font_type'),
                    font_size = this.model.get('font_size');

                this.pubSub.trigger('font_params:apply',
                    font_type, font_size
                );
            },
            afterRender: function() {
                this.fontSelector = this.$("#font_selector");
                this.fontSizeSelect = this.$("#selector_fontsize");

                //стартовые значения глобальных шрифтов
                var font_size, font_type;
                font_type = this.model.get('font_type');
                font_size = this.model.get('font_size');

                this.fontSelector.val(font_type);
                this.fontSizeSelect.val(font_size);

            },
			render: function() {
				this.$el.html(this.template);
				this.$el.css('padding', '1em');
				return this;
			}
		});

		return FontSetupView;
	}
);