define('views/template_manage_view', ['jquery', 'backbone', 'models/blank_model', 'helpers'],

	function($, Backbone, BlankModel, helpers) {

		var template = [

			'<div>',
			'<h3>Параметры шаблона</h3>',
			'<div id="template_name" class="instrument_line" style="width: 100%;">',
				'<div class="tbl_opt_label">',
					'<p class="inline">Имя шаблона</p>',
				'</div>',
				'<div class="tbl_opt" style="width: 40%; margin-right: 10px;">',
					'<input type="text"/ style="width: 100%">',
				'</div>',
				'<div class="btn tbl_opt" id="save_template">',
					'<input type="submit" value="Сохранить" name="save_btn"/>',
				'</div>',
			'</div>',
			'<div id="loaded_templates" class="instrument_line">',
				'<div class="tbl_opt_label">',
					'<p class="inline">Сохраненные</p>',
				'</div>',
				'<div class="tbl_opt" style="width: 40%; margin-right: 10px;">',
					'<select id="template_select" style="width: 100%">',
				'</select>',
				'</div>',
			'</div>',
			'<div id="background_select" class="instrument_line">',
				'<div class="tbl_opt_label">',
				'<p>Выбор бланка</p>',
				'</div>',
				'<form id="load_blank_form" enctype="multipart/form-data" method="POST" action="/upload_blank">',
				'<input type="file" name="select_file" style="width: 40%; margin-right: 10px;"/>',
				'<input type="file" name="old_file" class="hidden"/>',
				'<input id="template_path" type="text" name="template_path" class="hidden"/>',
				'<input id="tempfile" type="text" name="exist_tempfile" class="hidden"/>',
				'<input id="num_of_params" type="text" name="number_of_params" class="hidden"/>',
				'<input id="pack_url" type="text" name="pack_url" class="hidden"/>',
				'<input id="blank_size_val" type="text" name="blank_size" class="hidden"/>',
				'<input id="id_field_val" type="text" name="id_field" class="hidden"/>',
                '<input id="add_vals_field" type="text" name="add_vals" class="hidden"/>',
				'<input type="submit" value="Загрузить" name="load_background"/>',
				'</form>',
			'</div></div>'
		].join("\r\n");

		var TemplateManageView = Backbone.View.extend({
			template: template,
			tagName: 'div',
			events: {
				'change #template_name input'				: "updateModel",
				'click #save_template input[type=submit]' 	: "saveTemplate", 
				'focus #template_select' 					: 'preloadAllTemplates',
				'change #template_select' 					: 'setSaveUrl',
                'click submit'                              : 'loadSelectedTemplate'
			},

			initialize: function(config) {
				this.model = new BlankModel({
					start_template_name: config.template_name
				});
				this.editor = config['editor'];
				this.objectsCollection = config['objectsCollection'];
			},
			afterRender: function() {
				this.templateNameField = this.$("#template_name input[type=text]");
				this.templateToLoadSelector = this.$("#template_select");
                this.loadBlankForm = this.$('#load_blank_form');
                this.setLoadTemplatePostData();
                this.templateNameField.val(this.model.get('start_template_name'));
			},
			render: function() {
				this.$el.html(this.template);
				this.$el.css("padding", "1em");

				return this;
			},
			updateModel: function() {
				this.model.set('modified_template_name', this.templateNameField.val())
			},
			setSaveUrl: function() {
				this.model.set('template_name_load', this.templateToLoadSelector.val());
                this.setTemplateToLoad();
			},
            getSaveLoadTemplateData: function() {
                //получаем данные для сохранение/загрузки шаблона
                var par_model = this.editor.model;
                var template_name = this.templateNameField.val();
                return {
		            "name" 				: template_name,
		            "pack_url" 			: par_model.get('provider_url'),
		            "background_url" 	: par_model.get('background_img_url'),
		            "fix_x" 		 	: par_model.get('fix_x'),
		            "fix_y" 			: par_model.get('fix_y'),
		            "columns_count" 	: par_model.get('columns_count')  || 1,
		            "cell_rng_start" 	: par_model.get('cell_rng_start') || 0,
		            "cell_rng_end" 		: par_model.get('cell_rng_end')   || 0,
		            "offset_x" 			: par_model.get('offset_x'),
		            "offset_y" 			: par_model.get('offset_y'),
		            "hyphenation_on" 	: par_model.get('hyphenation_on') || false,
		            "font_type" 		: par_model.get('font_type')      || 'Arial',
		            "font_size" 		: par_model.get('font_size')      || 12
		        }
            },
			saveTemplate: function() {

				var attname, att_value, par_model, fixed_cells = [], user_cells = [], 
					offset_on = this.editor.model.get('offsetMode');

				if (offset_on) {
		            alert("Перед сохранением нужно снять флажок \"Вкл.сжатие отступы\"");
		            return;
		        }

				var template_name = this.model.get('modified_template_name') ||
                                    this.model.get('start_template_name');

				if (!template_name) {
					alert("Нужно задать имя для шаблона!");
					return;
				}
				//параметры которые необходимо взять из модели ячейки для сохранения
				var cell_attributes_to_save = [
					'leftOffset', 'topOffset',
                    'width', 'height', 'isNotPrinted',
					'getLinkId', 'getFontType', 'getFontSize'
				];

                var not_converted_atts = [
                    'isNotPrinted', 'getLinkId', 'getFontSize', 'getFontType'
                ];

				this.objectsCollection.each(function(cell) {
					var cell_info = [];
					for (var at = 0; at < cell_attributes_to_save.length; at++) {
						attname = cell_attributes_to_save[at];
						//если аттрибут является свойством
						if (cell[attname] && typeof(cell[attname]) == "function") {
                            //аргумент передаваемый функции означает что не нужно использовать
                            //форматирование значений из модели
							att_value = cell[attname](true);
						} else {
							//берем аттрибут у модели
							att_value = cell.get(attname);
						}

						//значения будут хранится в пикселях
                        if (!isNaN(parseFloat(att_value))) {
                            if (not_converted_atts.indexOf(attname) == -1) {
                                att_value = parseFloat(att_value);
                            } else {
                                att_value = parseFloat(att_value);
                            }
                        } else {
                            if (att_value === true) {
                                att_value = 1;
                            } else if (att_value === false) {
                                att_value = 0;
                            }
                        }
						cell_info.push(att_value);
					}
					//если поля является фиксированным то кладем в соответствующий массив
					if (cell.get('fixed')) {
						fixed_cells.push(cell_info);
					} else {
						//кладем в пользовательский массив
						user_cells.push(cell_info);
					}
				});

                var save_data = this.getSaveLoadTemplateData();
                save_data['coord_map'] = helpers.toJson(fixed_cells);
                save_data['user_map'] = helpers.toJson(user_cells);

				$.ajax({
		            url: this.editor.getActions().save_template,
		            type: 'POST',
		            data: save_data,
		            dataType: 'json',
		            success: function(data){
		                //добавляем новый шаблон если его там нет в список сохранненых

		                if (data.hasOwnProperty('success') && data.success==false) {
		                    if (data['message'])
		                        alert(data.message);
		                    else alert("Неизвестная ошибка при сохранении");
		                    return;
		                }

		                // var options = $("#template_select").find('option');
		                // var match = false;
		                // var new_template_field = $("#template_name").find('input[type=\"text\"]');

		                // var t_name = (new_template_field
		                //         && new_template_field.val());

		                // options.each(function(e) {
		                //     if ($(this).html() == t_name) {
		                //         match = true;
		                //     }
		                // })
		                // if (!match) {
		                //     var old_html = $("#template_name").find("select").html();
		                //     $("#template_name").find("select").html(old_html + "<option value=\""
		                //             + t_name + "\">"
		                //             + t_name + "</option>");
		                // }

		                alert("Шаблон успешно сохранен");
		            },
		            failure: function(data){
		                alert("Ошибка при сохранении шаблона");
		            }
		        });

			},
			loadTemplate: function() {
				console.log("preload template");
			},
            setTemplateToLoad: function() {
                //добавляем на форму загрузки шаблона параметр имени шаблона
                var form_ = this.loadBlankForm,
                    load_template_url = form_.attr("action").split("?")[0],
                    template_selector = this.templateToLoadSelector,
                    selected_template = template_selector.val();

                if (selected_template == null || !selected_template) {
                    selected_template = template_selector.children(0).eq(0).html();
                }
                console.log(selected_template);
                form_.attr("action", load_template_url + "?template_name="
                        + selected_template);
            },
			preloadAllTemplates: function() {
                var that = this;
                return $.ajax({
                    url: this.editor.getActions().load_template,
                    data: {
                        "pack_url": this.editor.model.get('provider_url')
                    },
                    dataType: 'json',
                    success: function(data) {
                        var html_ = '';
                        for (var d in data) {
                            html_ += '<option value=\"'+ data[d] + '\">' + data[d] + '</option>';
                        }
                        that.templateToLoadSelector.html(html_);
                        //на форму надо добавить GET параметр - имя шаблона для загрузки нужного шаблона
                        that.templateToLoadSelector.val(data[0]);
                        //если урл на загрузку не заполнен выбираем первый бланк по умолчанию
                        if (that.loadBlankForm) {
                            var upload_url = that.editor.getActions().upload_blank || '/upload_blank';
                            var url = that.loadBlankForm.attr('action').replace(upload_url, '');
                            if (url.length == 0) {
                                that.loadBlankForm.attr('action', upload_url+'?template_name=' + data[0]);
                            }
                        }
                    }
                })
			},
            setLoadTemplatePostData: function() {
                //загружаем выбранный шаблон из списка сохранненых
                //также если выбран файл для подложки
                //то загружаем и его
                var parmodel = this.editor.model,
                    post_params = parmodel.get('report_params');

                this.$('form #template_path')
                    .val(post_params['path_to_template']);
                this.$('form #tempfile')
                    .val(post_params['path_to_tempfile']);
                this.$('form #num_of_params')
                    .val(post_params['number_of_params']);
                this.$('form #pack_url')
                    .val(post_params['provider_url']);
                this.$('form #blank_size_val')
                    .val(post_params['blank_size']);
                this.$('form #id_field_val')
                    .val(post_params['id_field']);
                this.$('form #add_vals_field')
                    .val(post_params['additional_values']);
            }
		});

		return TemplateManageView;
	}
);