/**
 * Подсказка для вывода информации о выбранной ячейке
 */

define('views/tooltip_view', ['jquery', 'jquery_ui', 'backbone', 'paper', 'handlebars', 'models/tooltip_model'],

    function($, jQUI, Backbone, Paper, hbars, TooltipModel) {

        var extendModeTemplate = [
            '<div class="tooltip_row clear" style="width: 100%;">',
            '<div class="inrow" style="width: 200px;"><label for="linked_cells">Переносы слов:</label></div>',
            '<div class="inrow" style="width: 30%; margin-right: 0.5em;"><select id="linked_cells" style="width: 170px;"></select></div>',
            '<div class="inrow" style="width: 30%;"><button id="add_new_breakout">Создать перенос</button></div>',
            '</div>',
            '<div class="tooltip_row clear" style="width: 100%;">',
            '<div class="inrow"><label style="display: block; width: 200px;" for="link_cell_text">Текст переноса:</label></div>',
            '<div class="inrow" style="width: 29%; margin-right: 0.8em;"><input style="width: 100%;" type="text" id="link_cell_text"/></div>',
            '<div class="inrow" style="width: 30%;"><button id="remove_breakout">Удалить перенос</button><div>',
            '</div>',
            '<div class=\"tooltip_row link clear\"><input type=\"text\"/></div>'
        ];

        var template = function(extensions) {

            var preCompiledExtensions = [];

            for (var ex = 0; ex < extensions.length; ex++) {
                preCompiledExtensions.push(extensions[ex].join('\r\n'));
            }

            return [
                '<div class=\"tooltip\">',
                    '<div class=\"tooltip_row clear\">',
                        '<div class=\"font_select\" style="width: 60%">',
                            '<div class="inrow"><label style="display: block; width: 200px;">Шрифт ячейки: </label></div>',
                            '<div class="inrow" style="width: 40%;"><select style="width: 100%;"><option>Arial</option></select></div>',
                        '</div>',
                        '<div class=\"font_size\" style="width: 38%">',
                            '<div class="inrow"><label style="display: block; width: 140px;">Размер шрифта: </label></div>',
                            '<div class="inrow"><select><option>12</option></select></div>',
                        '</div>',
                    '</div>',
                    '<div class=\"tooltip_row base_text clear\" style="width: \'100%\'">',
                        '<label style="display: block; width: 200px;">Текст при загрузке: </label><div class="text"></div>',
                    '</div>',
                    '<div class=\"tooltip_row user_text clear\" style="width: \'100%\'">',
                        '<div class="inrow"><label style="display: block; width: 200px;">Текст пользователя: </label></div>',
                        '<div class="inrow" style="width: 60%"><input style="width: 100%;" type=\"text\"/></div>',
                    '</div>',
                    preCompiledExtensions.join('\r\n'),
                    "<div class='cell_id_value' style='display: none;'>{{getSelectedId}}</div>",
                '</div>'
            ].join("\r\n");
        };

        var saveCellParams = function (event, create_new_fields, linked_objects) {
            /*сохраняем параметры текста для выбранного поля*/
            //TODO - написать функцию получения экземпляра тултипа

            var view = saveCellParams.this_,
                view_el = view.$el;

            var tooltip = view_el.find('.tooltip'),
                cell_id = view_el.find('.cell_id_value').html(),
                selected_cell = view.collection.find(
                    function(cell) {
                        return cell.get('idx') == parseInt(cell_id);
                    }),
                text_params = selected_cell.get('text_params'),
                links = tooltip.find(".link"),
                text_rows = links.find("input"), //обновляемые строки
                font_selection_panel = tooltip.find(".tooltip_row").find("select"),
                font_type = font_selection_panel.eq(0),
                font_size = font_selection_panel.eq(1);

            //нужно проверить все ли связанные ячейки существуют

            text_rows.each(function(i) {
                //проставляем признак создания новой ячейки
                var idx = -1;

                if (create_new_fields) {
                    idx = linked_objects.indexOf(i);
                    if ((idx==-1) && !$(this).hasClass("add_field_action") && i>0) {
                        $(this).addClass("add_field_action");
                    }
                }

                if ($(this).hasClass("add_field_action")) {
                    var need_rows = (linked_objects.length + 1) - text_params.rows.length;

                    if (need_rows >= 0) {
                        text_params.rows.push($(this).val());
                        text_params.rows_offset.push(0);
                    }

                    //добавляем новое связанное поле
                    var new_field = Drawer.createSegmentRectangle(
                        new Point(20, 20), 20, 20, recs.length);

                    new_field.linked_id[0] = parseInt(selected_cell.idx);
                    new_field.linked_id[1] = i;
                    recs.push(new_field);

                    this.user_fields.push(recs.length - 1);

                    //добавляем поле в таблицу и ставим признак связности
                    var last_table = $("#coord_info table");

                    //TODO - нужно добавить сохранение состояния видимости при печати
                    //TODO - подписку на события организовать как отслеижвание событий вьюхи CoorView
                    var row_html = "<tr id=\"cinfo"+recs.length+"\"><td class=\"id_field\">"+recs.length+"</td><td><input type=\"text\" value=\""+ new_field.center.x.toFixed(2) + "\" onkeypress=\"updateCenterX(this,event)\"/></td><td><input type=\"text\" value=\"" +
                        + new_field.center.y.toFixed(2) + "\" onkeypress=\"updateCenterY(this,event)\"/></td><td><input type=\"text\" value=\"" +
                        + new_field.width.toFixed(2) + "\" onkeypress=\"updateRWidth(this,event)\"/></td><td><input type=\"text\" value=\"" + new_field.height.toFixed(2) + "\" onkeypress=\"updateRHeight(this,event)\"/></td><td class=\"link\">"+
                        + new_field.linked_id[0] + "</td><td><input type=\"checkbox\" onchange=\"printExclude(this)\"/></td><td><a href=\"#\" onclick=\"deleteUserField(this,"+ parseInt(recs.length-1) + ")\">УДАЛИТЬ</a></td>"
                        + "</tr>\r\n";

                    last_table.append(row_html);
                }
                else {
                    //эти ячейки обновляем
                    text_params.rows[i] = $(this).val() || view.userTextField.val();
                    text_params.rows_offset[i] = 0;
                }
            });
            //устанавливаем шрифт
            text_params.font_type = font_type.val();
            text_params.font_size = font_size.val();

            selected_cell.set('user_text', tooltip.find(".user_text").find("input").val());
            text_params.rows[0] = selected_cell.get('user_text') ?
                    selected_cell.get('user_text') : selected_cell.get('base_text');

            $(this).dialog('close');
            tooltip.remove();

            selected_cell.set('text_params', text_params);
        };

        var TooltipView = Backbone.View.extend({
            template: template,
            className: 'tooltip_wrapper',
            events: {
                'click #add_new_breakout'   : 'addNewBreakout',
                'click #remove_breakout'    : 'delBreakout'
            },

            initialize: function(config) {
                this.selectionModel = config.selectionModel;
                this.collection = config['cellCollection'];
                this.fontOptions = config['fontOptions'];
            },
            tooltipLoadInfo: function() {
                //загрузка данных на форму подсказки
                var text_params = this.selectedCell.get('text_params'),
                    cell_font_size, cell_font_type , cell_base_text,
                    default_font_size = 12, default_font_type = 'Arial';

                cell_font_size = text_params.font_size || default_font_size;
                cell_font_type = text_params.font_type || default_font_type;
                cell_base_text = text_params.rows[0] || this.selectedCell.get('base_text');

                this.fontSelection.val(cell_font_type);
                this.fontSizeSelect.val(cell_font_size);
                this.userTextField.val(cell_base_text);
            },
            addSelectableOptions: function(source, target, defaults) {
                //метод добавления опций выбора шрифта
                //если задан исходный элемент содержащий опции
                //то берем данные из этого элемента
                var fontsHtmlTag1 = '<option>',
                    fontsHtmlTag2 = '</option>',
                    fontsHtml = [], value,
                    fontOptions = (source && source.find('option')) ||
                        defaults || [];

                for (var fo = 0; fo < fontOptions.length; fo++) {
                    var jqObject = $(fontOptions[fo]);
                    value = (jqObject && jqObject.html) ? jqObject.html() : fontOptions[fo];
                    fontsHtml.push([fontsHtmlTag1, value, fontsHtmlTag2].join(""));
                }

                target.html(fontsHtml.join(""));
            },
            addFontTypeOptions: function(source) {
                //добавляем значения выбора для типа шрифта
                this.addSelectableOptions(source, this.fontSelection,
                                          this.fontTypeOptions);
            },
            addFontSizeOptions: function(source) {
                //добавляем значение выбора для размера шрифта
                this.addSelectableOptions(source, this.fontSizeSelect,
                                          this.fontSizeOptions);
            },
            afterRender: function() {
                var tooltip = this.$el,
                    selected_item = this.selectionModel.get('selected_item');

                this.selectedCell = this.collection.getParentGroup(selected_item.parent)[0];
                this.fontSelection = this.$('.font_select select');
                this.fontSizeSelect = this.$('.font_size select');
                this.baseTextField = this.$('.base_text input');
                this.userTextField = this.$('.user_text input');


                if (!this.showLink) {
                    this.$('.link').css('display', 'none');
                }

                if (!this.showLoadText) {
                    this.$('.base_text').css('display', 'none');
                }
                saveCellParams.this_ = this;

                this.$el.dialog({
                    title: 'Редактирование ячейки',
                    autoOpen: true,
                    modal: false,
                    height: this.extendTooltipView ? 300: 240,
                    width: 600,
                    position: [
                        selected_item.position.x,
                        selected_item.position.y
                    ],
                    close: function (event, ui) {
                        tooltip.remove();
                    },
                    buttons: [
                        {text: 'Сохранить', click: saveCellParams}
                    ]
                });
                var buttons = this.$el.parent().find('button');
                this.saveButton = buttons.eq(0);
                this.saveButton.attr('id', 'save_cell_params');
                this.saveButton.on('click', saveCellParams, this);
                this.addLinkButton = this.$('#add_new_breakout');
            },

            render: function() {

                var model = new TooltipModel(),
                    tpl, preCompiledTemplate,
                    model_dump = model.toJSON(),
                    tooltip = this.$el,
                    collection = this.collection,
                    selected_item = this.selectionModel.get('selected_item'),
                    selected_cell, extensions;

                extensions = this.extendTooltipView ? [extendModeTemplate] : [];

                if (typeof(template) == "function") {
                    preCompiledTemplate = template(extensions);
                }

                tpl = Handlebars.compile(preCompiledTemplate);

                selected_cell = collection.getParentGroup(selected_item.parent)[0];
                model_dump['getSelectedId'] = selected_cell.get('idx');
                tooltip.html(tpl(model_dump));

                return this;
            }

        }, {
            hideTooltip: function(sm) {
                var tooltip = $('.tooltip_wrapper');
                //убираем
                if (tooltip.length) {
                    tooltip.dialog('close');
                }
            }
        });

        function addRow() {
            /**
                функция добавления нового связанного поля для переноса слов
             */

            var that = this,
                sel_model = this.selection_model,
                parent_id = sel_model.getParentGroup(selected_item.parent),
                tooltip = this.$el;

            if (tooltip) {
                var new_row = tooltip.find(".tooltip_row"),
                    first_row = new_row.find("input");

                tooltip.append("<div class=\"clear\"></div><div class=\"tooltip_row link\"><input type=\"text\" class=\"add_field_action\" size=\"" + first_row.attr("size") + "\"/><div class=\".tooltip_btn\" onclick=\"delRow()\"></div></div>");
                //расширяем ширину тултипа на величину высоты новой строки
                tooltip.css("height", (parseInt(tooltip.css("height")) + 30).toString() + "px");
                //добавляем признак того что надо добавить на канвас новое поле
            }
        }

        function setTooltipLinkParams(selectionCell) {

            var tooltip = this.$el,
                field_text,
                text_params = selectionCell.get('text_params'),
                cell_value = selectionCell.get('value'),
                cell_link = selectionCell.get('linked_id');

            if (cell_value || cell_link[0] != -1) {

                var first_row = this.$(".link").find("input");
                //добавляем строки в подсказку если есть связанные поля
                for (var k = 0; k < text_params.rows.length - 1; k++) {

                    tooltip.append("<div class=\"clear\"></div><div class=\"tooltip_row link\"><input type=\"text\" size=\"" +
                        first_row.attr("size") + "\"/><div class=\".tooltip_btn\" onclick=\"delRow()\"></div></div>");

                    //расширяем ширину тултипа на величину высоты новой строки
                    tooltip.css("height", (parseInt(tooltip.css("height")) + 30).toString()+"px");
                }

                if (cell_value && cell_link[0] == -1) {
                    field_text = cell_value.content;
//                    text_length = field_text ? field_text.length : 1;
//                    symbol_width = (cell_value.strokeBounds.width / text_length);
                }

                //берем значение поля из связи с основным полем
                else if (cell_link[0] != -1) {
                    //TEST
                    field_text = text_params.rows[cell_link[1]];
//                    text_length = field_text ? field_text.length : 1;
//                    symbol_width = 2;
                }

            }
        }

        function setTooltipTextParams(selectionTextParams) {

            var text_rows = this.$(".link");

            text_rows.each(function(l) {
                var inp = $(this).find("input");

                if (inp.attr("type") == "text")
                    inp.attr("size", (text_length + 5).toString());

                if (selectionTextParams.rows.length == 0 ||
                   (selectionTextParams.rows.length > 0 &&
                   !selectionTextParams.rows[0])) {
                    
                    inp.val(field_text);
                }
                else {
                    
                    inp.val(selectionTextParams.rows[l]);
                }
            });
        }

        function showTooltip(selectionModel) {

//            var cvas = $("#paperCanvas");
            //показываем подсказку на элемент
            //selected_item - выбранный элемент
            var tmodel = this.model,
                tooltip = this.$el,
                selected_item = selectionModel.get('selected_item'),
                collection = selectionModel.get('collection'),
                sbounds = selected_item.parent.strokeBounds,
                tooltip_lft = sbounds.x,
                tooltip_top = sbounds.y - sbounds.height/2,
                selection = collection.getParentGroup(selected_item.parent),
                selected_cell = selection[0],
                parent_id = selection[1] || -1;

            if (parent_id == -1) {
                return;
            }

            if (tmodel.get('isOn') || !parent_id) {
                if (parent_id == parseInt(tooltip.attr("id"))) return;

                this.remove();
                tmodel.set('isOn', false);
            }

            $("body").append(tooltip_html);

            var ttip_el = $(".tooltip"),
                //добавим шрифты и размеры в "подсказку"
                font_select_el = $("#font_selector"),
                select_font_el = $("#selector_fontsize"),
                //копируем все значения для шрифтов и размеров из элементов на главной панели
                slt_font = this.fontSelection.find("select"),
                slt_size = this.fontSizeSelect.find(".font_size").find("select");

            //устанавливаем базовый текст для элемента
            this.baseTextField.find(".text").html(selected_cell.get('base_text'));
            this.userTextField.find("input").val(selected_cell.get('user_text'));

            slt_font.html(font_select_el.html());
            slt_size.html(select_font_el.html());

            var text_params = selected_cell.get('text_params');

            if (!text_params.font_type.length && !text_params.font_size.length) {

                slt_font.val(font_select_el.val());
                slt_size.val(select_font_el.val());

            } else {

                slt_font.val(text_params.font_type);
                slt_size.val(text_params.font_size);
            }

            //добавляем класс который используется если мы показываем подсказку для одного и того же элемента
            tooltip.attr("id", parent_id);
//
//            var text_length = 0, symbol_width = 0,
//                field_text = '';
                
            setTooltipLinkParams();

            //размещаем элемент подсказки на холсте
//            var ttip_left_position = (parseFloat(cvas.attr("left")) || 0) + parseFloat(cvas.attr("width"));
//            var ttip_top_position = (parseFloat(cvas.attr("top")) || 0) + parseFloat(cvas.attr("height")) + 20;

            setTooltipTextParams(text_params);
            
//            ttip_el.css("top", ttip_top_position.toString() + "px")
//                .css("width", (parseInt($("#blank_container")
//                .css("width"))+80).toString()+"px");
        }

        return TooltipView;
    }
);
