
requirejs.config({
    baseUrl: staticUrl + 'js/libs',
    paths: {
        jquery          : 'jquery',
        jquery_ui       : 'jquery-ui-1.10.3',
        json            : 'json-2.4',
        handlebars      : 'handlebars-v1.3.0',
        spec            : '../test/jasmine/spec/',
        tech            : '../tech',
        cells           : '../tech/cells',
        drawing         : '../tech/drawing',
        hyphenation     : '../tech/hyphenation',
        helpers         : '../tech/helpers',
        toolpanel       : '../tech/toolpanel',
        models          : '../tech/models',
        views           : '../tech/views',
        collections     : '../tech/collections'
        // akordeon        : 'jquery.akordeon'
//        zones:          '../tech/zones'
    },
    shim: {
        'backbone': {
            deps: ['underscore', 'jquery'],
            exports: 'Backbone'
        },
        'underscore': {
            exports: '_'
        },
        'paper': {
            exports: 'Paper'
        },
        'handlebars-v1.3.0': {
            exports: 'handlebars'
        },
        // 'jquery-ui-1.10.3': {
        //     exports: 'jquery_ui',
        //     deps: ['jquery']
        // },
        'json-2.4': {
            exports: 'json',
            deps: ['jquery']
        },
        jasmine: {
            exports: 'jasmine'
        },
        'jasmine-html': {
            deps: ['jasmine'],
            exports: 'jasmine'
        }
        // 'akordeon': {
        //     exports: 'JQuery.fn.akordeon',
        //     deps: ['jquery']
        // }
    }
});

requirejs(['underscore', 'jquery', 'jasmine-html'], function(_, $, jasmine) {

    var jasmineEnv = jasmine.getEnv();
    jasmineEnv.updateInterval = 1000;

    var htmlReporter = new jasmine.HtmlReporter();

    jasmineEnv.addReporter(htmlReporter);

    jasmineEnv.specFilter = function(spec) {
      return htmlReporter.specFilter(spec);
    };

    var specs = [
        'spec/EditorViewSpec'
    ];

    require(specs, function execJasmine() {
        jasmineEnv.execute();
    });
});

