
function startBlankEditor(config, onRequestStartFunc, onRequestEndFunc, parseValuesFunc) {
    /*функция запускает редактор бланков
     */

    var field_id_value = config['field_id_value'] || 0,
        report_pack = config['provider_name'],
        get_report_data_url = config['get_report_data_url'],
        number_of_params = config['number_of_params'],
        params = config['report_params'],
        start_editor_url = config['start_editor_url'];
    //извлечение значений из дополнительных элементов на форме
    var add_elements = config['additional_values'] || [],
        add_values = '{';
    //достаем данные не привязанные непосредственно к записям в журналах
    if (add_elements.constructor == Array) {
        for (var e = 0; e < add_elements.length; e++) {
            var el = parseValuesFunc(add_elements[e]);
            var prefix = ',';
            if (e == 0) prefix = '';
            add_values += prefix + '\"' + el.name + '\":' + '\"' + el.getValue() + '\"';
        }
    }
    else if (add_elements.constructor == Object) {
        var cnt = 0;
        for (var v in add_elements) {
            var prefix = ',';
            if (cnt == 0) prefix = '';
            add_values += prefix + '\"' + v + '\":' + '\"' + add_elements[v] + '\"';
            cnt+=1;
        }
    }
    add_values += '}';

    if (onRequestStartFunc && typeof(onRequestStartFunc) == "function") {
        onRequestEndFunc();
    }

    var start_editor_request = function(base_params) {

        $.ajax({
            url : start_editor_url,
            data: base_params,
            dataType: 'json',
            type: 'POST',
            success: function(res, opt) {
                window.open(res.location);
                if (onRequestEndFunc && typeof(onRequestEndFunc) == "function") {
                    onRequestEndFunc();
                }
            }
        });
    };

    var req = function () {
        $.ajax({
            url: get_report_data_url,
            dataType: 'json',
            type: 'POST',
            data: {
                pack_url : report_pack,
                id_field : field_id_value,
                add_vals : add_values
            },
            success: function(res, opt) {
//            if (obj.success === false) {
//                smart_eval(res.responseText);
//                return;
//            }
                var values = res[0], descriptions = res[1],
                    num_of_params = values.length,
                    base_params = {
                        report_data: $.toJSON(values),
                        data_description: $.toJSON(descriptions || []),
                        pack_url: report_pack,
                        id_field: field_id_value,
                        number_of_params: parseInt(number_of_params) || num_of_params,
                        add_vals: add_values
                    };

                $.extend(true, base_params, params);

                start_editor_request(base_params);
            }
        });
    };
    req();

}



