import os
from django.conf import settings
from django.conf.urls.defaults import patterns
from .api import BlankGenerator
import views

url_config = BlankGenerator.get_url_config()

urlpatterns = patterns('',

    (r'^test_report$',                        views.test_report_view),
    (r'^test_runner$',                        views.test_runner),
    (r'^'+url_config['get_report_data'],      views.get_data_for_report),
    (r'^'+url_config['start_editor'],         views.print_template),
    (r'^'+url_config['get_templates'],        views.get_all_templates),
    (r'^'+url_config['save_new_background'],  views.get_template_background),
    (r'^'+url_config['save_new_template'],    views.save_template),

    (r'^editor_static/(?P<path>.*)$', 'django.views.static.serve',
         {'document_root': settings.BLANK_EDITOR_STATIC_ROOT}),
    (r'^editor_media/(?P<path>.*)$', 'django.views.static.serve',
         {'document_root': settings.BLANK_EDITOR_MEDIA_ROOT})
)

if getattr(settings, 'BLANK_PROJECT', None):
    urlpatterns += patterns('',
        (r'^$',                                    views.main, ))